| Version: 3.0.2

- Main Page
- Related Pages
- Categories
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | List of all members
wxClipboard Class Reference
Clipboard and Drag & Drop

`#include <wx/clipbrd.h>`

Inheritance diagram for wxClipboard:
[legend]

## Detailed Description

A class for manipulating the clipboard.

To use the clipboard, you call member functions of the global wxTheClipboard object.

See the wxDataObject Overview for further information.

Call wxClipboard::Open() to get ownership of the clipboard. If this operation returns true, you now own the clipboard. Call wxClipboard::SetData() to put data on the clipboard, or wxClipboard::GetData() to retrieve data from the clipboard. Call wxClipboard::Close() to close the clipboard and relinquish ownership. You should keep the clipboard open only momentarily.

For example:

// Write some text to the clipboard
if (wxTheClipboard->Open())
{
// This data objects are held by the clipboard,
// so do not delete them in the app.
wxTheClipboard->SetData( new wxTextDataObject("Some text") );
wxTheClipboard->Close();
}
// Read some text
if (wxTheClipboard->Open())
{
if (wxTheClipboard->IsSupported( wxDF_TEXT ))
{
wxTextDataObject data;
wxTheClipboard->GetData( data );
wxMessageBox( data.GetText() );
}
wxTheClipboard->Close();
}

##

Library: wxCore
Category: Clipboard and Drag & Drop

See Also
  Drag and Drop Overview, wxDataObject Overview, wxDataObject

## Public Member Functions
| wxClipboard ()
| Default constructor.
virtual | ~wxClipboard ()
| Destructor.
virtual bool | AddData (wxDataObject *data)
| Call this function to add the data object to the clipboard.
virtual void | Clear ()
| Clears the global clipboard object and the system's clipboard if possible.
virtual void | Close ()
| Call this function to close the clipboard, having opened it with Open().
virtual bool | Flush ()
| Flushes the clipboard: this means that the data which is currently on clipboard will stay available even after the application exits (possibly eating memory), otherwise the clipboard will be emptied on exit.
virtual bool | GetData (wxDataObject &data)
| Call this function to fill data with data on the clipboard, if available in the required format.
virtual bool | IsOpened () const
| Returns true if the clipboard has been opened.
virtual bool | IsSupported (const wxDataFormat &format)
| Returns true if there is data which matches the data format of the given data object currently available on the clipboard.
bool | IsUsingPrimarySelection () const
| Returns true if we are using the primary selection, false if clipboard one.
virtual bool | Open ()
| Call this function to open the clipboard before calling SetData() and GetData().
virtual bool | SetData (wxDataObject *data)
| Call this function to set the data object to the clipboard.
virtual void | UsePrimarySelection (bool primary=false)
| On platforms supporting it (all X11-based ports), wxClipboard uses the CLIPBOARD X11 selection by default.
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data.
| wxObject (const wxObject &other)
| Copy ctor.
virtual | ~wxObject ()
| Destructor.
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar).
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object.
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class.
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj.
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone.
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer.
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data.
void | UnShare ()
| This is the same of AllocExclusive() but this method is public.
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined.
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined.

## Static Public Member Functions
static wxClipboard * | Get ()
| Returns the global instance (wxTheClipboard) of the clipboard object.

## Additional Inherited Members
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object.
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it.
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data.
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data.

## Constructor & Destructor Documentation

wxClipboard::wxClipboard | ( |  | ) |

Default constructor.

virtual wxClipboard::~wxClipboard | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

virtual bool wxClipboard::AddData | ( | wxDataObject * | data | ) |
| virtual

Call this function to add the data object to the clipboard.

You may call this function repeatedly after having cleared the clipboard using Clear().

After this function has been called, the clipboard owns the data, so do not delete the data explicitly.

See Also
  SetData()

virtual void wxClipboard::Clear | ( |  | ) |
| virtual

Clears the global clipboard object and the system's clipboard if possible.

virtual void wxClipboard::Close | ( |  | ) |
| virtual

Call this function to close the clipboard, having opened it with Open().

virtual bool wxClipboard::Flush | ( |  | ) |
| virtual

Flushes the clipboard: this means that the data which is currently on clipboard will stay available even after the application exits (possibly eating memory), otherwise the clipboard will be emptied on exit.

Currently this method is not implemented in X11-based ports, i.e. wxGTK, wxX11 and wxMotif and always returns false there.

Returns
  false if the operation is unsuccessful for any reason.

static wxClipboard* wxClipboard::Get | ( |  | ) |
| static

Returns the global instance (wxTheClipboard) of the clipboard object.

virtual bool wxClipboard::GetData | ( | wxDataObject & | data | ) |
| virtual

Call this function to fill data with data on the clipboard, if available in the required format.

Returns true on success.

virtual bool wxClipboard::IsOpened | ( |  | ) | const
| virtual

Returns true if the clipboard has been opened.

virtual bool wxClipboard::IsSupported | ( | const wxDataFormat & | format | ) |
| virtual

Returns true if there is data which matches the data format of the given data object currently available on the clipboard.

Todo:
  The name of this function is misleading. This should be renamed to something that more accurately indicates what it does.

bool wxClipboard::IsUsingPrimarySelection | ( |  | ) | const

Returns true if we are using the primary selection, false if clipboard one.

See Also
  UsePrimarySelection()

virtual bool wxClipboard::Open | ( |  | ) |
| virtual

Call this function to open the clipboard before calling SetData() and GetData().

Call Close() when you have finished with the clipboard. You should keep the clipboard open for only a very short time.

Returns
  true on success. This should be tested (as in the sample shown above).

virtual bool wxClipboard::SetData | ( | wxDataObject * | data | ) |
| virtual

Call this function to set the data object to the clipboard.

This function will clear all previous contents in the clipboard, so calling it several times does not make any sense.

After this function has been called, the clipboard owns the data, so do not delete the data explicitly.

See Also
  AddData()

virtual void wxClipboard::UsePrimarySelection | ( | bool | primary = `false` | ) |
| virtual

On platforms supporting it (all X11-based ports), wxClipboard uses the CLIPBOARD X11 selection by default.

When this function is called with true, all subsequent clipboard operations will use PRIMARY selection until this function is called again with false.

On the other platforms, there is no PRIMARY selection and so all clipboard operations will fail. This allows to implement the standard X11 handling of the clipboard which consists in copying data to the CLIPBOARD selection only when the user explicitly requests it (i.e. by selecting the "Copy" menu command) but putting the currently selected text into the PRIMARY selection automatically, without overwriting the normal clipboard contents with the currently selected text on the other platforms.